import java.util.ArrayList;
import java.util.Random;

ArrayList<Robot> myRobots =
              new ArrayList<Robot>();

void setup(){
   size(600,600);
   frameRate(60);
}

void draw(){
  // initialize a robot
  // at the location of the click
  if (mousePressed){
     int newSpeed = Robot.rng.nextInt(10)+1; 
     Robot r = new Robot(mouseX,mouseY, 20, newSpeed);
     myRobots.add(r);
     System.out.println("Created a new robot");
     
     // wait for half a second after creating a enw robot
     delay(500);
  }
  background(127);
  
  // here we draw all the robots
  for (int i = 0; i<myRobots.size(); i++){
    Robot r = myRobots.get(i);
    // update the robot's position
    // apply attractive force
    r.applyForce(mouseX,mouseY);
    // apply a repulsive force, based on the location of the rest of the robots
    for ( int j = 0; j < myRobots.size(); j++){
       if ( i != j){
          Robot q = myRobots.get(j);
          
          r.applyForce(q.getX(),q.getY());
       } 
    }
    r.update();
    System.out.println(r.getX()+", "+r.getY());
    ellipse(r.getX(),r.getY(),r.diameter,r.diameter);
  }
}

void keyPressed(){
   if ( key == 'x' || key == 'X' ){
       int n = myRobots.size();
       Random rng = new Random();
       try{
         int robotToKill = rng.nextInt(n-1);
         myRobots.remove(robotToKill);
       } catch (Exception e){
          System.out.println("No more Robots to kill"); 
       }
   } 
}
